import AlertKonfirmasi from "@/components/alertKonfirmasi";
import BorderBottomItem from "@/components/borderBottomItem";
import { ButtonForm } from "@/components/buttonForm";
import ButtonTab from "@/components/buttonTab";
import DrawerBottom from "@/components/drawerBottom";
import { InputForm } from "@/components/inputForm";
import InputSearch from "@/components/inputSearch";
import MenuItemRow from "@/components/menuItemRow";
import SkeletonTwoItem from "@/components/skeletonTwoItem";
import Text from "@/components/Text";
import { ColorsStatus } from "@/constants/ColorsStatus";
import Styles from "@/constants/Styles";
import { apiDeletePosition, apiEditPosition, apiGetPosition } from "@/lib/api";
import { setUpdatePosition } from "@/lib/positionSlice";
import { useAuthSession } from "@/providers/AuthProvider";
import { AntDesign, Feather, MaterialCommunityIcons } from "@expo/vector-icons";
import { useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { RefreshControl, View, VirtualizedList } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

type Props = {
   name: string;
   idGroup: string;
   group: string;
   id: string;
   isActive: boolean
}

export default function Index() {
   const arrSkeleton = Array.from({ length: 5 }, (_, index) => index)
   const [loading, setLoading] = useState(true)
   const { token, decryptToken } = useAuthSession()
   const [status, setStatus] = useState<'true' | 'false'>('true')
   const entityUser = useSelector((state: any) => state.user)
   const { active, group } = useLocalSearchParams<{ active?: string, group?: string }>()
   const [isModal, setModal] = useState(false)
   const [isVisibleEdit, setVisibleEdit] = useState(false)
   const [data, setData] = useState<Props[]>([])
   const [search, setSearch] = useState('')
   const [nameGroup, setNameGroup] = useState('')
   const [loadingSubmit, setLoadingSubmit] = useState(false)
   const [chooseData, setChooseData] = useState({ name: '', id: '', active: false, idGroup: '' })
   const [error, setError] = useState({
      name: false,
   });
   const [refreshing, setRefreshing] = useState(false)

   const dispatch = useDispatch()
   const update = useSelector((state: any) => state.positionUpdate)

   async function handleLoad(loading: boolean) {
      try {
         setLoading(loading)
         const hasil = await decryptToken(String(token?.current))
         const response = await apiGetPosition({ user: hasil, active: status, search: search, group: String(group) })
         setData(response.data)
         setNameGroup(response.filter.name)
      } catch (error) {
         console.error(error)
      } finally {
         setLoading(false)
      }
   }

   useEffect(() => {
      handleLoad(false)
   }, [update])


   useEffect(() => {
      handleLoad(true)
   }, [status, search, group])


   function handleChooseData(id: string, name: string, active: boolean, group: string) {
      setChooseData({ id, name, active, idGroup: group })
      setModal(true)
   }

   async function handleDelete() {
      try {
         const hasil = await decryptToken(String(token?.current))
         const response = await apiDeletePosition({ user: hasil, isActive: chooseData.active }, chooseData.id)
         dispatch(setUpdatePosition(!update))
      } catch (error) {
         console.error(error)
      } finally {
         setModal(false)
         Toast.show({ type: 'small', text1: 'Berhasil mengupdate data', })
      }
   }


   async function handleEdit() {
      try {
         setLoadingSubmit(true)
         const hasil = await decryptToken(String(token?.current))
         const response = await apiEditPosition({ user: hasil, name: chooseData.name, idGroup: chooseData.idGroup }, chooseData.id)
         if (response.success) {
            dispatch(setUpdatePosition(!update))
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error) {
         console.error(error)
      } finally {
         setLoadingSubmit(false)
         setVisibleEdit(false)
         setModal(false)
      }

   }

   function validationForm(value: string) {
      setChooseData({ ...chooseData, name: value })
      if (value == "") {
         setError({ ...error, name: true })
      } else {
         setError({ ...error, name: false })
      }
   }

   function checkForm() {
      if (Object.values(error).some((v) => v == true))
         return false
      handleEdit()
   }

   const handleRefresh = async () => {
      setRefreshing(true)
      handleLoad(false)
      await new Promise(resolve => setTimeout(resolve, 2000));
      setRefreshing(false)
   };


   const getItem = (_data: unknown, index: number): Props => ({
      id: data[index].id,
      name: data[index].name,
      idGroup: data[index].idGroup,
      group: data[index].group,
      isActive: data[index].isActive,
   });

   return (
      <View style={[Styles.p15, { flex: 1 }]}>
         <View>
            <View style={[Styles.wrapBtnTab]}>
               <ButtonTab
                  active={status == "false" ? "false" : "true"}
                  value="true"
                  onPress={() => { setStatus("true") }}
                  label="Aktif"
                  icon={<Feather name="check-circle" color={status == "true" ? 'white' : 'black'} size={20} />}
                  n={2} />
               <ButtonTab
                  active={status == "false" ? "false" : "true"}
                  value="false"
                  onPress={() => { setStatus("false") }}
                  label="Tidak Aktif"
                  icon={<AntDesign name="closecircleo" color={status == "false" ? 'white' : 'black'} size={20} />}
                  n={2} />
            </View>
            <InputSearch onChange={setSearch} />
            {
               (entityUser.role == "supadmin" || entityUser.role == "developer") &&
               <View style={[Styles.mv05]}>
                  <Text>Filter : {nameGroup}</Text>
               </View>
            }
         </View>
         <View style={[{ flex: 2 }, Styles.mt05]}>
            {
               loading ?
                  arrSkeleton.map((item, index) => {
                     return (
                        <SkeletonTwoItem key={index} />
                     )
                  })
                  :
                  data.length > 0 ?
                     <VirtualizedList
                        data={data}
                        getItemCount={() => data.length}
                        getItem={getItem}
                        renderItem={({ item, index }: { item: Props, index: number }) => {
                           return (
                              <BorderBottomItem
                                 key={index}
                                 onPress={() => {
                                    entityUser.role != "user" &&
                                       handleChooseData(item.id, item.name, item.isActive, item.idGroup)
                                 }}
                                 borderType="all"
                                 icon={
                                    <View style={[Styles.iconContent, ColorsStatus.lightGreen]}>
                                       <MaterialCommunityIcons name="account-tie" size={25} color={'#384288'} />
                                    </View>
                                 }
                                 title={item.name}
                                 subtitle={item.group}
                              />
                           )
                        }}
                        keyExtractor={(item, index) => String(index)}
                        showsVerticalScrollIndicator={false}
                        refreshControl={
                           <RefreshControl
                              refreshing={refreshing}
                              onRefresh={handleRefresh}
                           />
                        }
                     />
                     :
                     <Text style={[Styles.textDefault, Styles.cGray, { textAlign: 'center' }]}>Tidak ada data</Text>
            }
         </View>
         <DrawerBottom animation="slide" isVisible={isModal} setVisible={() => setModal(false)} title={chooseData.name}>
            <View style={Styles.rowItemsCenter}>
               <MenuItemRow
                  icon={<MaterialCommunityIcons name="toggle-switch-off-outline" color="black" size={25} />}
                  title={chooseData.active ? 'Non Aktifkan' : "Aktifkan"}
                  onPress={() => {
                     setModal(false)
                     AlertKonfirmasi({
                        title: 'Konfirmasi',
                        desc: chooseData.active ? 'Apakah anda yakin ingin menonaktifkan data?' : 'Apakah anda yakin ingin mengaktifkan data?',
                        onPress: () => { handleDelete() }
                     })
                  }}
               />
               <MenuItemRow
                  icon={<MaterialCommunityIcons name="pencil-outline" color="black" size={25} />}
                  title="Edit"
                  onPress={() => {
                     setModal(false)
                     setTimeout(() => {
                        setVisibleEdit(true)
                     }, 600)
                  }}
               />
            </View>
         </DrawerBottom>


         <DrawerBottom animation="none" keyboard height={30} backdropPressable={false} isVisible={isVisibleEdit} setVisible={() => setVisibleEdit(false)} title="Edit Jabatan">
            <View style={{ justifyContent: 'space-between', flex: 1 }}>
               <View>
                  <InputForm
                     type="default"
                     placeholder="Nama Jabatan"
                     required
                     label="Jabatan"
                     value={chooseData.name}
                     onChange={(val) => { validationForm(val) }}
                     error={error.name}
                     errorText="Nama jabatan tidak boleh kosong"
                  />
               </View>
               <View style={Styles.mb30}>
                  <ButtonForm text="SIMPAN" onPress={() => { handleEdit() }} disabled={Object.values(error).some((v) => v == true) || chooseData.name == "" || loadingSubmit} />
               </View>
            </View>
         </DrawerBottom>
      </View>
   )
}